Index: java/main/src/main/java/com/framsticks/communication/ClientConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ClientConnection.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/communication/ClientConnection.java	(revision 88)
@@ -32,9 +32,16 @@
 	protected final Map<String, Subscription<?>> subscriptions = new HashMap<>();
 
-	public String getAddress() {
-		return address;
-	}
-
-	public void connect(StateFunctor connectedFunctor) {
+	/**
+	 * @param connectedFunctor the connectedFunctor to set
+	 */
+	public void setConnectedFunctor(StateFunctor connectedFunctor) {
+		this.connectedFunctor = connectedFunctor;
+	}
+
+
+	protected StateFunctor connectedFunctor;
+
+	@Override
+	protected void joinableStart() {
 		try {
 			log.info("connecting to " + address);
@@ -46,5 +53,4 @@
 			log.info("connected to " + hostName + ":" + port);
 			connected = true;
-
 			runThreads();
 
@@ -56,7 +62,8 @@
 			log.error("buffer creation failure");
 			connectedFunctor.call(e);
-			close();
-		}
-	}
+			// close();
+		}
+	}
+
 
 	private static abstract class InboundMessage {
@@ -149,5 +156,4 @@
 
 
-	protected final String address;
 	protected final String hostName;
 	protected final int port;
@@ -156,6 +162,5 @@
 
 	public ClientConnection(String address) {
-		assert address != null;
-		this.address = address;
+		super(address);
 		Matcher matcher = addressPattern.matcher(address);
 		if (!matcher.matches()) {
@@ -235,5 +240,5 @@
 	@Override
 	public String toString() {
-		return address;
+		return "client connection " + address;
 	}
 
@@ -328,5 +333,5 @@
 	private int nextQueryId = 0;
 
-	protected void processMessage(InboundMessage inboundMessage) throws Exception {
+	protected void processMessage(InboundMessage inboundMessage) {
 		if (inboundMessage == null) {
 			log.error("failed to use any inbound message");
@@ -342,5 +347,5 @@
 	}
 
-	protected void processEvent(String rest) throws Exception {
+	protected void processEvent(String rest) {
 		Matcher matcher = eventPattern.matcher(rest);
 		if (!matcher.matches()) {
@@ -359,5 +364,5 @@
 
 
-	protected void processMessageStartingWith(String line) throws Exception {
+	protected void processMessageStartingWith(String line) {
 		Pair<String, String> command = Strings.splitIntoPair(line, ' ', "\n");
 		if (command.first.equals("event")) {
@@ -384,9 +389,14 @@
 
 	@Override
-	protected void receiverThreadRoutine() throws Exception {
+	protected void receiverThreadRoutine() {
 		while (connected) {
-			processMessageStartingWith(getLine());
-		}
-	}
+			try {
+				processMessageStartingWith(getLine());
+			} catch (Exception e) {
+				break;
+			}
+		}
+	}
+
 
 }
Index: java/main/src/main/java/com/framsticks/communication/Connection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 88)
@@ -1,4 +1,5 @@
 package com.framsticks.communication;
 
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.io.Encoding;
 import com.framsticks.util.lang.Pair;
@@ -14,8 +15,14 @@
 import java.util.regex.Pattern;
 
+import com.framsticks.util.dispatching.AbstractJoinable;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableCollection;
+import com.framsticks.util.dispatching.JoinableParent;
+import com.framsticks.util.dispatching.JoinableState;
 import com.framsticks.util.dispatching.RunAt;
 import com.framsticks.util.dispatching.Thread;
 
-public abstract class Connection {
+public abstract class Connection extends AbstractJoinable implements JoinableParent {
 
 	protected final static Logger log = Logger.getLogger(Connection.class);
@@ -32,44 +39,25 @@
 	protected int protocolVersion = -1;
 
+	public String getAddress() {
+		return address;
+	}
+	protected final String address;
+
 	protected final Thread<Connection> senderThread = new Thread<>();
 	protected final Thread<Connection> receiverThread = new Thread<>();
-
+	protected final JoinableCollection<Thread<Connection>> threads = new JoinableCollection<>(true);
+
+	/**
+	 *
+	 */
+	public Connection(String address) {
+		this.address = address;
+		threads.add(senderThread);
+		threads.add(receiverThread);
+	}
 	public boolean isConnected() {
 		return connected;
 	}
 
-	public void close() {
-		protocolVersion = -1;
-		try {
-			connected = false;
-
-			senderThread.interrupt();
-			senderThread.join();
-
-			receiverThread.interrupt();
-			receiverThread.join();
-
-			if (output != null) {
-				output.close();
-				output = null;
-			}
-
-			if (input != null) {
-				input.close();
-				input = null;
-			}
-
-
-			if (socket != null) {
-				socket.close();
-				socket = null;
-			}
-
-			log.info("connection closed");
-		} catch (Exception e) {
-			log.error(e);
-		}
-
-	}
 
 	protected static final String ARGUMENT_PATTERN_FRAGMENT = "((?:\\S+)|(?:\"[^\"]*\"))";
@@ -95,34 +83,42 @@
 	char[] readBuffer = new char[BUFFER_LENGTH];
 
-	protected String getLine() throws Exception {
+	protected String getLine() {
 		StringBuilder lineBuffer = new StringBuilder();
-		while (!Thread.interrupted()) {
-			while (iterator < readChars) {
-				if (readBuffer[iterator] != '\n') {
+		try {
+			while (!Thread.interrupted()) {
+				while (iterator < readChars) {
+					if (readBuffer[iterator] != '\n') {
+						++iterator;
+						continue;
+					}
+					lineBuffer.append(readBuffer, bufferStart, iterator - bufferStart + 1);
 					++iterator;
-					continue;
+					bufferStart = iterator;
+					return lineBuffer.toString();
 				}
-				lineBuffer.append(readBuffer, bufferStart, iterator - bufferStart + 1);
-				++iterator;
-				bufferStart = iterator;
-				return lineBuffer.toString();
-			}
-			lineBuffer.append(readBuffer, bufferStart, readChars - bufferStart);
-
-			readChars = 0;
-			while (readChars == 0) {
-				try {
-					readChars = input.read(readBuffer);
-				} catch (SocketTimeoutException ignored) {
-					//timeout - continue
+				lineBuffer.append(readBuffer, bufferStart, readChars - bufferStart);
+
+				readChars = 0;
+				while (readChars == 0) {
+					try {
+						readChars = input.read(readBuffer);
+					} catch (SocketTimeoutException ignored) {
+						//timeout - continue
+					}
 				}
-			}
-			iterator = 0;
-			bufferStart = 0;
-		}
-		throw new InterruptedException();
-	}
-
-	protected abstract void receiverThreadRoutine() throws Exception;
+				iterator = 0;
+				bufferStart = 0;
+			}
+			throw new InterruptedException();
+		} catch (Exception e) {
+			throw new FramsticksException().msg("failed to read line").cause(e);
+		}
+	}
+
+	protected abstract void receiverThreadRoutine();
+
+	protected void setUpThread(Thread<Connection> thread, String name) {
+		thread.setName("connection thread " + address + " " + name);
+	}
 
 	protected void runThreads() {
@@ -132,30 +128,19 @@
 		} catch (IOException e) {
 			log.error("buffer creation failure");
-			close();
 			return;
 		}
 
-		senderThread.setName(this + "-sender");
-		receiverThread.setName(this + "-receiver");
-
-		senderThread.start();
-		receiverThread.start();
+		setUpThread(senderThread, "sender");
+		setUpThread(receiverThread, "receiver");
+		Dispatching.use(threads, this);
 
 		receiverThread.invokeLater(new RunAt<Connection>() {
 			@Override
 			public void run() {
-				try {
-					receiverThreadRoutine();
-				} catch (InterruptedException ignored) {
-					log.debug("receiver thread interrupted");
-				} catch (Exception e) {
-					log.error("error: " + e);
-					close();
-				}
+				receiverThreadRoutine();
 			}
 		});
 
 	}
-
 
 	/**
@@ -164,10 +149,52 @@
 	 * @return Query associated with query getId.
 	 */
-
 	public int getProtocolVersion() {
 		return protocolVersion;
 	}
 
-
+	@Override
+	protected void joinableInterrupt() {
+		protocolVersion = -1;
+
+		connected = false;
+		Dispatching.drop(threads, this);
+
+		// finish();
+	}
+
+	@Override
+	protected void joinableFinish() {
+		try {
+			if (output != null) {
+				output.close();
+				output = null;
+			}
+
+			if (input != null) {
+				input.close();
+				input = null;
+			}
+
+
+			if (socket != null) {
+				socket.close();
+				socket = null;
+			}
+		} catch (Exception e) {
+			log.error("failed to stop connection: ", e);
+		}
+		log.debug("connection closed");
+	}
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		proceedToState(state);
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		Dispatching.join(threads);
+
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/core/AbstractInstanceListener.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/AbstractInstanceListener.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/core/AbstractInstanceListener.java	(revision 88)
@@ -0,0 +1,25 @@
+package com.framsticks.core;
+
+public abstract class AbstractInstanceListener implements InstanceListener {
+
+	@Override
+	public void onListChange(Path path, ListChange change) {
+
+	}
+
+	@Override
+	public void onFetch(Path path) {
+
+	}
+
+	@Override
+	public void onRun(Exception e) {
+
+	}
+
+	@Override
+	public void onStop(Exception e) {
+
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/core/Entity.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Entity.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/core/Entity.java	(revision 88)
@@ -1,14 +1,7 @@
 package com.framsticks.core;
 
-import javax.annotation.OverridingMethodsMustInvokeSuper;
 
 import com.framsticks.params.annotations.FramsClassAnnotation;
-import com.framsticks.params.annotations.ParamAnnotation;
-import com.framsticks.util.dispatching.Thread;
-import com.framsticks.util.dispatching.Dispatcher;
-
-import org.apache.commons.configuration.Configuration;
-import org.apache.log4j.Logger;
-import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.dispatching.Joinable;
 
 /**
@@ -16,99 +9,35 @@
  */
 @FramsClassAnnotation
-public abstract class Entity implements Dispatcher<Entity> {
+public interface Entity extends Joinable {
 
-	private final static Logger log = Logger.getLogger(Entity.class);
+	public String getName();
 
-	@ParamAnnotation
-	protected String name = "entity";
-	protected EntityOwner owner;
-	protected Dispatcher<Entity> dispatcher;
-
-	public Entity() {
-	}
-
-	public final String getName() {
-		return name;
-	}
-
-	/**
-	 * @param name the name to set
-	 */
-	public final void setName(String name) {
-		this.name = name;
-		if (dispatcher instanceof Thread) {
-			((Thread<Entity>) dispatcher).setName(name);
-		}
-	}
-
-	/**
-	 * @return the owner
-	 */
-	public EntityOwner getOwner() {
-		return owner;
-	}
-
-	/**
-	 * @param owner the owner to set
-	 */
-	public void setOwner(EntityOwner owner) {
-		this.owner = owner;
-	}
-
-	@Override
-	public final boolean isActive() {
-		return dispatcher == null || dispatcher.isActive();
-	}
-
-	@Override
-	public final void invokeLater(RunAt<? extends Entity> runnable) {
-		assert dispatcher != null;
-		dispatcher.invokeLater(runnable);
-	}
-
-	public Dispatcher<Entity> createDefaultDispatcher() {
-		return new Thread<Entity>(name).start();
-	}
-
-	@OverridingMethodsMustInvokeSuper
-	protected void run() {
-		assert isActive();
-		log.info("running: " + this);
-	}
+	// /**
+	//  * @param name the name to set
+	//  */
+	// @ParamAnnotation
+	// public final void setName(String name) {
+	// 	this.name = name;
+	// 	if (dispatcher instanceof Thread) {
+	// 		((Thread<Entity>) dispatcher).setName(name);
+	// 	}
+	// }
 
 
-	public void configure(Configuration config) {
-	}
+	// public Dispatcher<Entity> createDefaultDispatcher() {
+	// 	return new Thread<Entity>().setName(name).start();
+	// }
 
-	public Dispatcher<Entity> getDispatcher() {
-		return dispatcher;
-	}
-
-	/**
-	 * @param dispatcher the dispatcher to set
-	 */
-	public void setDispatcher(Dispatcher<Entity> dispatcher) {
-		this.dispatcher = dispatcher;
-	}
-
-	public final void start() {
-		if (dispatcher == null) {
-			log.debug("no dispatcher set for " + this + ", creating default one");
-			setDispatcher(createDefaultDispatcher());
-		}
-		invokeLater(new RunAt<Entity>() {
-			@Override
-			public void run() {
-				Entity.this.run();
-			}
-		});
-	}
-
-	public final void done() {
-		log.info("stopping entity");
-		if (owner != null) {
-			owner.onDone();
-		}
-	}
-
+	// public void start() {
+	// 	if (dispatcher == null) {
+	// 		log.debug("no dispatcher set for " + this + ", creating default one");
+	// 		dispatcher = createDefaultDispatcher();
+	// 	}
+	// 	invokeLater(new RunAt<Entity>() {
+	// 		@Override
+	// 		public void run() {
+	// 			Entity.this.run();
+	// 		}
+	// 	});
+	// }
 }
Index: java/main/src/main/java/com/framsticks/core/Framsticks.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Framsticks.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/core/Framsticks.java	(revision 88)
@@ -0,0 +1,47 @@
+package com.framsticks.core;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.parsers.XmlLoader;
+import com.framsticks.util.dispatching.JoinableCollection;
+import com.framsticks.util.dispatching.JoinableMonitor;
+
+import org.apache.log4j.Logger;
+import org.apache.log4j.PropertyConfigurator;
+
+import java.io.InputStream;
+
+/**
+ * @author Piotr Sniegowski
+ */
+@FramsClassAnnotation
+public class Framsticks extends JoinableCollection<Entity> {
+	private static final Logger log = Logger.getLogger(Framsticks.class);
+
+	public Framsticks() {
+		PropertyConfigurator.configure(getClass().getResource("/configs/log4j.properties"));
+	}
+
+	public static Framsticks loadConfiguration(InputStream stream) {
+		return new XmlLoader().load(stream, Framsticks.class);
+	}
+
+	public static void main(final String[] args) {
+
+		final Framsticks framsticks = loadConfiguration(Framsticks.class.getResourceAsStream("/configs/framsticks.xml"));
+
+		new JoinableMonitor(framsticks).use().waitFor().drop().join();
+
+		// monitor.use();
+		// monitor.waitFor();
+		// monitor.drop();
+		// monitor.join();
+
+		log.info("exiting main");
+	}
+
+	@Override
+	public String toString() {
+		return "framsticks";
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/core/Instance.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Instance.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/core/Instance.java	(revision 88)
@@ -1,23 +1,40 @@
 package com.framsticks.core;
 
-import com.framsticks.communication.*;
-import com.framsticks.params.*;
+import java.util.HashSet;
+import java.util.Iterator;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Set;
+
+import javax.annotation.Nonnull;
+import javax.annotation.OverridingMethodsMustInvokeSuper;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.communication.File;
+import com.framsticks.params.AccessInterface;
+import com.framsticks.params.ConstructionException;
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.ListAccess;
+import com.framsticks.params.Param;
+import com.framsticks.params.Registry;
+import com.framsticks.params.ValueParam;
+import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.types.ObjectParam;
 import com.framsticks.parsers.Loaders;
 import com.framsticks.parsers.MultiParamLoader;
-import com.framsticks.util.*;
+import com.framsticks.util.StateFunctor;
 import com.framsticks.util.UnsupportedOperationException;
 import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.dispatching.Thread;
 import com.framsticks.util.lang.Casting;
-import org.apache.log4j.Logger;
-import com.framsticks.util.dispatching.RunAt;
-
-import java.util.*;
 
 /**
  * @author Piotr Sniegowski
  */
-public abstract class Instance extends Entity {
+@FramsClassAnnotation
+public abstract class Instance extends Thread<Instance> implements Entity {
 
 	private static final Logger log = Logger.getLogger(Instance.class.getName());
@@ -25,14 +42,8 @@
 	protected Node root;
 
-	public Set<InstanceListener> listeners = new HashSet<InstanceListener>();
+	protected Set<InstanceListener> listeners = new HashSet<InstanceListener>();
 
 	public Instance() {
-	}
-
-	@Override
-	protected void run() {
-		super.run();
-		root = new Node(Param.build().name("Instance").id(name).type("o"), null);
-		com.framsticks.model.Package.register(registry);
+		setName("entity");
 	}
 
@@ -262,10 +273,10 @@
 
 
-	public FramsClass processFetchedInfo(File file) {
+	public @Nonnull FramsClass processFetchedInfo(File file) {
 		assert isActive();
 		FramsClass framsClass = Loaders.loadFramsClass(file.getContent());
 		if ("/".equals(file.getPath())) {
 			if (root.getParam().getContainedTypeName() == null) {
-				root = new Node(Param.build().name("Instance").id(name).type("o " + framsClass.getId()), root.getObject());
+				root = new Node(Param.build().name("Instance").id(getName()).type("o " + framsClass.getId()), root.getObject());
 			}
 		}
@@ -346,4 +357,12 @@
 		return getPath("/");
 	}
+
+	@Override
+	@OverridingMethodsMustInvokeSuper
+	protected void firstTask() {
+		root = new Node(Param.build().name("Instance").id(getName()).type("o"), null);
+		com.framsticks.model.Package.register(registry);
+	}
+
 }
 
Index: java/main/src/main/java/com/framsticks/core/LocalInstance.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/LocalInstance.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/core/LocalInstance.java	(revision 88)
@@ -4,5 +4,4 @@
 import com.framsticks.util.dispatching.Thread;
 
-import org.apache.commons.configuration.Configuration;
 import org.apache.log4j.Logger;
 
@@ -27,18 +26,18 @@
 	}
 
-	@Override
-	public void configure(Configuration config) {
-		Integer accept = config.getInteger("accept", null);
-		if (accept != null) {
-			try {
-				acceptSocket = new ServerSocket();
-				acceptSocket.setReuseAddress(true);
-				acceptThread = new Thread<Accept>(name + "-accept").start();
-				tryBind(accept);
-			} catch (IOException e) {
-				log.fatal("failed to create accept socket: " + e);
-			}
-		}
-	}
+	// @Override
+	// public void configure(Configuration config) {
+	// 	Integer accept = config.getInteger("accept", null);
+	// 	if (accept != null) {
+	// 		try {
+	// 			acceptSocket = new ServerSocket();
+	// 			acceptSocket.setReuseAddress(true);
+	// 			acceptThread = new Thread<Accept>().setName(name + "-accept").start();
+	// 			tryBind(accept);
+	// 		} catch (IOException e) {
+	// 			log.fatal("failed to create accept socket: " + e);
+	// 		}
+	// 	}
+	// }
 
 	protected final Set<InstanceClient> clients = new HashSet<InstanceClient>();
Index: java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java
===================================================================
--- java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java	(revision 88)
@@ -1,13 +1,34 @@
 package com.framsticks.diagnostics;
 
-import org.apache.commons.configuration.Configuration;
 
-import com.framsticks.observers.Endpoint;
-import com.framsticks.observers.Observer;
+import java.util.Date;
+import java.io.File;
+import java.io.FileOutputStream;
+import java.io.IOException;
+import java.io.OutputStreamWriter;
+import java.io.PrintWriter;
+import java.text.SimpleDateFormat;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.core.AbstractInstanceListener;
+import com.framsticks.core.Instance;
+import com.framsticks.dumping.PrintWriterSink;
+import com.framsticks.dumping.SaveStream;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.remote.RecursiveFetcher;
+import com.framsticks.util.Logging;
+import com.framsticks.util.PeriodicTask;
+import com.framsticks.util.StateFunctor;
+import com.framsticks.util.dispatching.JoinableCollection;
+import com.framsticks.util.io.Encoding;
 
 /**
  * @author Piotr Sniegowski
  */
-public class Diagnostics extends Observer {
+public class Diagnostics extends JoinableCollection<Instance> {
+	private static final Logger log =
+		Logger.getLogger(Diagnostics.class);
+
 
 	Integer dumpsInterval;
@@ -19,18 +40,65 @@
 	}
 
+
 	@Override
-	public void configure(Configuration config) {
-		super.configure(config);
-		dumpsInterval = config.getInteger("dumps.interval", null);
-		dumpsPath = config.getString("dumps.path", null);
-		dumpsFormat = config.getString("dumps.format", null);
+	@AutoAppendAnnotation
+	public void add(final Instance instance) {
+		super.add(instance);
+
+		instance.addListener(new AbstractInstanceListener() {
+			@Override
+			public void onRun(Exception e) {
+				if (e != null) {
+					return;
+				}
+
+				if (dumpsInterval != null) {
+					new PeriodicTask<Instance>(instance, dumpsInterval * 1000) {
+						@Override
+						public void run() {
+
+							log.info("starting periodic dump");
+							new RecursiveFetcher(instance, instance.getRootPath(), new StateFunctor() {
+								@Override
+								public void call(Exception e) {
+									if (Logging.log(log, "recursively fetch", instance, e)) {
+										again();
+										return;
+									}
+									log.info("instance resolved, saving");
+									try {
+										final String fileName = dumpsPath + "/" + instance + "_" + new SimpleDateFormat(dumpsFormat).format(new Date()) + ".param";
+										File file = new File(fileName);
+										new SaveStream(new PrintWriterSink(new PrintWriter(new OutputStreamWriter(new FileOutputStream(file), Encoding.getFramsticksCharset()))), instance, instance.getRootPath(), new StateFunctor() {
+											@Override
+											public void call(Exception e) {
+												Logging.log(log, "periodic dump in " + fileName + " of", instance, e);
+												again();
+											}
+										});
+									} catch (IOException ex) {
+										log.info("failed to initiate dump: " + ex);
+										again();
+									}
+
+								}
+							});
+						}
+					};
+				}
+			}
+		});
+
+
+
 	}
 
-
-	@Override
-	protected Endpoint createEndpoint() {
-		return new DiagnosticsEndpoint();
-	}
-
+	// @Override
+	// public void configure(Configuration config) {
+	//	super.configure(config);
+	//	dumpsInterval = config.getInteger("dumps.interval", null);
+	//	dumpsPath = config.getString("dumps.path", null);
+	//	dumpsFormat = config.getString("dumps.format", null);
+	// }
 
 }
Index: java/main/src/main/java/com/framsticks/dumping/FileInstance.java
===================================================================
--- java/main/src/main/java/com/framsticks/dumping/FileInstance.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/dumping/FileInstance.java	(revision 88)
@@ -4,8 +4,9 @@
 import com.framsticks.core.Path;
 import com.framsticks.core.Instance;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.io.Encoding;
 
-import org.apache.commons.configuration.Configuration;
 import org.apache.log4j.Logger;
 
@@ -16,7 +17,10 @@
 import java.io.InputStreamReader;
 
+import javax.annotation.OverridingMethodsMustInvokeSuper;
+
 /**
  * @author Piotr Sniegowski
  */
+@FramsClassAnnotation
 public class FileInstance extends LocalInstance {
 
@@ -27,14 +31,19 @@
 	}
 
-	@Override
-	public void configure(Configuration config) {
-		super.configure(config);
-		file = new File(config.getString("filename"));
+	@ParamAnnotation
+	public void setFilename(String filename) {
+		file = new File(filename);
+	}
+
+	@ParamAnnotation
+	public String getFilename() {
+		return file.getName();
 	}
 
 	@Override
-	public void run() {
+	@OverridingMethodsMustInvokeSuper
+	protected void firstTask() {
 		assert isActive();
-		super.run();
+		super.firstTask();
 		try {
 			LoadStream stream = new LoadStream(this.getRootPath(), new BufferedReader(new InputStreamReader(new FileInputStream(file), Encoding.getFramsticksCharset())), this, new Future<Path>() {
Index: java/main/src/main/java/com/framsticks/examples/GenotypeBrowser.java
===================================================================
--- java/main/src/main/java/com/framsticks/examples/GenotypeBrowser.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/examples/GenotypeBrowser.java	(revision 88)
@@ -2,14 +2,11 @@
 
 import com.framsticks.core.Instance;
-import com.framsticks.core.Node;
 import com.framsticks.dumping.PrintWriterSink;
 import com.framsticks.model.*;
-import com.framsticks.model.Package;
+import com.framsticks.model.f0.Schema;
 import com.framsticks.params.*;
 import com.framsticks.parsers.F0Parser;
 import com.framsticks.parsers.F0Writer;
-import com.framsticks.parsers.Schema;
 
-import org.apache.commons.configuration.Configuration;
 import org.apache.log4j.Logger;
 
@@ -17,4 +14,6 @@
 import java.io.StringWriter;
 import java.util.List;
+
+import javax.annotation.OverridingMethodsMustInvokeSuper;
 
 /**
@@ -31,27 +30,29 @@
 	}
 
-	@Override
-	public void configure(Configuration config) {
-		super.configure(config);
-		try {
-			schema = new Schema(Schema.getDefaultDefinitionAsStream());
-		} catch (Exception e) {
-			log.error("failed to load schema: " + e);
-		}
-		this.registry = schema.getRegistry();
-		Package.register(this.getRegistry());
+	// @Override
+	// public void configure(Configuration config) {
+	// 	super.configure(config);
+	// 	try {
+	// 		schema = Schema.load(Schema.getDefaultDefinitionAsStream());
+	// 	} catch (Exception e) {
+	// 		log.error("failed to load schema: " + e);
+	// 	}
+	// 	this.registry = schema.getRegistry();
+	// 	Package.register(this.getRegistry());
 
-		registry.putInfoIntoCache(FramsClass.build()
-				.idAndName("ModelBuilderRoot")
-				.param(Param.build().id("model").type("o Model").name("model"))
-				.param(Param.build().id("genotype").type("s 1").name("genotype"))
-				.finish()
-		);
-		root = new Node(Param.build().type("o ModelBuilderRoot").id(name).name("Instance"), PropertiesAccess.createPropertiesMap());
-	}
+	// 	registry.putInfoIntoCache(FramsClass.build()
+	// 			.idAndName("ModelBuilderRoot")
+	// 			.param(Param.build().id("model").type("o Model").name("model"))
+	// 			.param(Param.build().id("genotype").type("s 1").name("genotype"))
+	// 			.finish()
+	// 	);
+	// 	root = new Node(Param.build().type("o ModelBuilderRoot").id(name).name("Instance"), PropertiesAccess.createPropertiesMap());
+	// }
 
 	@Override
-	protected void run() {
+	@OverridingMethodsMustInvokeSuper
+	protected void firstTask() {
 		assert isActive();
+		super.firstTask();
 
 		try {
